diff --git a/src/main/java/net/minecraft/core/entity/EntityFlying.java b/src/main/java/net/minecraft/core/entity/FlyingMob.java
similarity index 68%
rename from src/main/java/net/minecraft/core/entity/EntityFlying.java
rename to src/main/java/net/minecraft/core/entity/FlyingMob.java
index 809ffc691..908d7bf25 100644
--- a/src/main/java/net/minecraft/core/entity/EntityFlying.java
+++ b/src/main/java/net/minecraft/core/entity/FlyingMob.java
@@ -2,23 +2,23 @@ package net.minecraft.core.entity;
 
 
 // Referenced classes of package net.minecraft.src:
-//            EntityLiving, MathHelper, AxisAlignedBB, World, 
+//            Mob, MathHelper, AxisAlignedBB, World,
 //            Block
 
 import net.minecraft.core.block.Block;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 
-public class EntityFlying extends EntityLiving
+public class FlyingMob extends Mob
 {
 
-    public EntityFlying(World world)
+    public FlyingMob(World world)
     {
         super(world);
     }
 
     @Override
-	protected void causeFallDamage(float f)
+	protected void causeFallDamage(float distance)
     {
     }
 
@@ -46,10 +46,10 @@ public class EntityFlying extends EntityLiving
             if(onGround)
             {
                 f2 = 0.5460001F;
-                int i = world.getBlockId(MathHelper.floor_double(x), MathHelper.floor_double(bb.minY) - 1, MathHelper.floor_double(z));
+                int i = world.getBlockId(MathHelper.floor(x), MathHelper.floor(bb.minY) - 1, MathHelper.floor(z));
                 if(i > 0)
                 {
-                    f2 = Block.blocksList[i].movementScale * 0.91F;
+                    f2 = Block.blocksList[i].friction * 0.91F;
                 }
             }
             float f3 = 0.1627714F / (f2 * f2 * f2);
@@ -58,10 +58,10 @@ public class EntityFlying extends EntityLiving
             if(onGround)
             {
                 f2 = 0.5460001F;
-                int j = world.getBlockId(MathHelper.floor_double(x), MathHelper.floor_double(bb.minY) - 1, MathHelper.floor_double(z));
+                int j = world.getBlockId(MathHelper.floor(x), MathHelper.floor(bb.minY) - 1, MathHelper.floor(z));
                 if(j > 0)
                 {
-                    f2 = Block.blocksList[j].movementScale * 0.91F;
+                    f2 = Block.blocksList[j].friction * 0.91F;
                 }
             }
             move(xd, yd, zd);
@@ -69,16 +69,16 @@ public class EntityFlying extends EntityLiving
             yd *= f2;
             zd *= f2;
         }
-        prevLimbYaw = limbYaw;
+        walkAnimSpeedO = walkAnimSpeed;
         double d = x - xo;
         double d1 = z - zo;
-        float f4 = MathHelper.sqrt_double(d * d + d1 * d1) * 4F;
+        float f4 = MathHelper.sqrt(d * d + d1 * d1) * 4F;
         if(f4 > 1.0F)
         {
             f4 = 1.0F;
         }
-        limbYaw += (f4 - limbYaw) * 0.4F;
-        limbSwing += limbYaw;
+        walkAnimSpeed += (f4 - walkAnimSpeed) * 0.4F;
+        walkAnimPos += walkAnimSpeed;
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/core/entity/EntityItem.java b/src/main/java/net/minecraft/core/entity/ItemEntity.java
similarity index 56%
rename from src/main/java/net/minecraft/core/entity/EntityItem.java
rename to src/main/java/net/minecraft/core/entity/ItemEntity.java
index 70bb17571..a4394a968 100644
--- a/src/main/java/net/minecraft/core/entity/EntityItem.java
+++ b/src/main/java/net/minecraft/core/entity/ItemEntity.java
@@ -7,39 +7,49 @@ import com.mojang.nbt.CompoundTag;
 // Referenced classes of package net.minecraft.src:
 //            Entity, MathHelper, World, Material, 
 //            AxisAlignedBB, Block, NBTTagCompound, ItemStack, 
-//            EntityPlayer, InventoryPlayer, AchievementList, Item
+//            Player, InventoryPlayer, Achievements, Item
 
-import net.minecraft.core.achievement.AchievementList;
+import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.achievement.stat.StatList;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockLog;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.LogBlock;
 import net.minecraft.core.block.material.Material;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.Item;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 
-public class EntityItem extends Entity
+public class ItemEntity extends Entity
 {
+    private static final int LIFETIME = 6000;
+    public ItemStack item;
+    public int age;
+    public int pickupDelay;
+    private int health;
+    public float bobOffset;
+    public int basketPickupDelay = 0;
+    public static boolean enableItemClumping = true;
 
-    public EntityItem(World world, double x, double y, double z, ItemStack itemstack) {
+    public ItemEntity(World world, double x, double y, double z, ItemStack itemstack) {
         super(world);
         age = 0;
         health = 5;
-        initialRotation = (float)(java.lang.Math.random() * Math.PI * 2D);
+        bobOffset = (float)(Math.random() * Math.PI * 2D);
         setSize(0.25F, 0.25F);
         heightOffset = bbHeight / 2.0F;
         setPos(x, y, z);
         item = itemstack;
-        yRot = (float)(java.lang.Math.random() * 360D);
-        xd = (float)(java.lang.Math.random() * 0.20000000298023224D - 0.10000000149011612D);
-        yd = 0.20000000298023224D;
-        zd = (float)(java.lang.Math.random() * 0.20000000298023224D - 0.10000000149011612D);
+        yRot = (float)(Math.random() * 360D);
+        xd = (float)(Math.random() * 0.2D - 0.1D);
+        yd = 0.2D;
+        zd = (float)(Math.random() * 0.2D - 0.1D);
         if(itemstack == null) {
-        	System.err.println("Created EntityItem with no item!");
+        	System.err.println("Created ItemEntity with no item!");
         	Thread.dumpStack();
         }
     }
@@ -50,18 +60,18 @@ public class EntityItem extends Entity
         return false;
     }
 
-    public EntityItem(World world)
+    public ItemEntity(World world)
     {
         super(world);
         age = 0;
         health = 5;
-        initialRotation = (float)(java.lang.Math.random() * 3.1415926535897931D * 2D);
+        bobOffset = (float)(Math.random() * Math.PI * 2D);
         setSize(0.25F, 0.25F);
         heightOffset = bbHeight / 2.0F;
     }
 
     @Override
-	protected void init()
+	protected void defineSynchedData()
     {
     }
 
@@ -70,7 +80,7 @@ public class EntityItem extends Entity
     {
         super.tick();
         if(item == null) {
-            System.err.println("Removing EntityItem with no item!");
+            System.err.println("Removing ItemEntity with no item!");
             Thread.dumpStack();
             remove();
             return;
@@ -81,17 +91,17 @@ public class EntityItem extends Entity
         }
         
         
-        if(delayBeforeCanPickup > 0)
+        if(pickupDelay > 0)
         {
-            delayBeforeCanPickup--;
+            pickupDelay--;
         }
         xo = x;
         yo = y;
         zo = z;
-        yd -= 0.039999999105930328D;
-        if(world.getBlockMaterial(MathHelper.floor_double(x), MathHelper.floor_double(y), MathHelper.floor_double(z)) == Material.lava)
+        yd -= 0.04D;
+        if(world.getBlockMaterial(MathHelper.floor(x), MathHelper.floor(y), MathHelper.floor(z)) == Material.lava)
         {
-            yd = 0.20000000298023224D;
+            yd = 0.2D;
             xd = (random.nextFloat() - random.nextFloat()) * 0.2F;
             zd = (random.nextFloat() - random.nextFloat()) * 0.2F;
             world.playSoundAtEntity(null, this, "random.fizz", 0.4F, 2.0F + random.nextFloat() * 0.4F);
@@ -102,25 +112,25 @@ public class EntityItem extends Entity
         
         if(!world.isClientSide) {
         	if(enableItemClumping) {
-                if(MathHelper.floor_double(x) != MathHelper.floor_double(xo) || MathHelper.floor_double(y) != MathHelper.floor_double(yo) || MathHelper.floor_double(z) != MathHelper.floor_double(zo) || age % 25 == 0) {
+                if(MathHelper.floor(x) != MathHelper.floor(xo) || MathHelper.floor(y) != MathHelper.floor(yo) || MathHelper.floor(z) != MathHelper.floor(zo) || age % 25 == 0) {
                 	clumpToNearbyStack();
                 }		
         	}
         }
         
-        float f = 0.98F;
+        float friction = 0.98F;
         if(onGround)
         {
-            f = 0.5880001F;
-            int i = world.getBlockId(MathHelper.floor_double(x), MathHelper.floor_double(bb.minY) - 1, MathHelper.floor_double(z));
-            if(i > 0)
+            friction = 0.588F;
+            int blockId = world.getBlockId(MathHelper.floor(x), MathHelper.floor(bb.minY) - 1, MathHelper.floor(z));
+            if(blockId > 0)
             {
-                f = Block.blocksList[i].movementScale * 0.98F;
+                friction = Block.blocksList[blockId].friction * 0.98F;
             }
         }
-        xd *= f;
-        yd *= 0.98000001907348633D;
-        zd *= f;
+        xd *= friction;
+        yd *= 0.98D;
+        zd *= friction;
 
         if (wasInWater)
         {
@@ -135,9 +145,8 @@ public class EntityItem extends Entity
         {
             yd *= -0.5D;
         }
-        field_803_e++;
         age++;
-        if(age >= 6000)
+        if(age >= LIFETIME)
         {
             remove();
         }
@@ -188,38 +197,41 @@ public class EntityItem extends Entity
     }
 
 	@Override
-	public void playerTouch(EntityPlayer player) {
+	public void playerTouch(Player player) {
 		if(world.isClientSide) {
 			return;
 		}
-		if(delayBeforeCanPickup == 0) {
+		if(pickupDelay == 0) {
 			int previousStackSize = item.stackSize;
 			player.inventory.insertItem(item, true);
 
 			if(item.stackSize < previousStackSize) {
 				if(item.itemID < 16384) {
-					if(Block.blocksList[item.itemID] instanceof BlockLog) {
-						player.triggerAchievement(AchievementList.MINE_WOOD);
+					if(Block.blocksList[item.itemID] instanceof LogBlock) {
+						player.triggerAchievement(Achievements.MINE_WOOD);
 					}
 				}
-				if(item.itemID == Item.leather.id) {
-					player.triggerAchievement(AchievementList.KILL_COW);
+				if(item.itemID == Items.LEATHER.id) {
+					player.triggerAchievement(Achievements.KILL_COW);
 				}
-				if(item.itemID == Block.ice.id) {
-					player.triggerAchievement(AchievementList.CRUSH_BLOCKS);
+				if(item.itemID == Blocks.ICE.id) {
+					player.triggerAchievement(Achievements.CRUSH_BLOCKS);
 				}
 				
 				if(item.stackSize <= 0) {
 					world.playSoundAtEntity(player, this, "random.pop", 0.2F, ((random.nextFloat() - random.nextFloat()) * 0.7F + 1.0F) * 2.0F);
-					player.onItemPickup(this, item.itemID);	
+					player.onItemPickup(this, item);
 				}
 
-				if(item.itemID == Item.lanternFireflyGreen.id
-						|| item.itemID == Item.lanternFireflyBlue.id
-						|| item.itemID == Item.lanternFireflyOrange.id
-						|| item.itemID == Item.lanternFireflyRed.id) {
-					if(player.getStat(StatList.pickUpItemStats[Item.lanternFireflyRed.id]) > 0 && player.getStat(StatList.pickUpItemStats[Item.lanternFireflyGreen.id]) > 0 && player.getStat(StatList.pickUpItemStats[Item.lanternFireflyBlue.id]) > 0 && player.getStat(StatList.pickUpItemStats[Item.lanternFireflyOrange.id]) > 0) {
-						player.triggerAchievement(AchievementList.CAUGHT_EM_ALL);
+				if(item.itemID == Items.LANTERN_FIREFLY_GREEN.id
+						|| item.itemID == Items.LANTERN_FIREFLY_BLUE.id
+						|| item.itemID == Items.LANTERN_FIREFLY_ORANGE.id
+						|| item.itemID == Items.LANTERN_FIREFLY_RED.id) {
+					if( player.getStat(Items.LANTERN_FIREFLY_RED.getStat(StatList.STAT_PICKED_UP)) > 0 &&
+                            player.getStat(Items.LANTERN_FIREFLY_GREEN.getStat(StatList.STAT_PICKED_UP)) > 0 &&
+                            player.getStat(Items.LANTERN_FIREFLY_BLUE.getStat(StatList.STAT_PICKED_UP)) > 0 &&
+                            player.getStat(Items.LANTERN_FIREFLY_ORANGE.getStat(StatList.STAT_PICKED_UP)) > 0) {
+						player.triggerAchievement(Achievements.CAUGHT_EM_ALL);
 					}
 				}
 
@@ -231,14 +243,14 @@ public class EntityItem extends Entity
 	}
 
     public void clumpToNearbyStack() {
-    	AABB boundingBox = this.bb.expand(0.5, 0.0, 0.5);
-    	List<Entity> entities = world.getEntitiesWithinAABB(EntityItem.class, boundingBox);
+    	AABB boundingBox = this.bb.grow(0.5, 0.0, 0.5);
+    	List<Entity> entities = world.getEntitiesWithinAABB(ItemEntity.class, boundingBox);
     	
     	for(Entity otherEntity : entities) {
-    		if(otherEntity == this || !(otherEntity instanceof EntityItem) || !otherEntity.isAlive() || !this.isAlive()) {
+    		if(otherEntity == this || !(otherEntity instanceof ItemEntity) || !otherEntity.isAlive() || !this.isAlive()) {
     			continue;
     		}
-    		EntityItem otherItemEntity = (EntityItem) otherEntity;
+    		ItemEntity otherItemEntity = (ItemEntity) otherEntity;
     		
     		ItemStack thisItemStack = this.item;
     		ItemStack otherItemStack = otherItemEntity.item;
@@ -257,20 +269,11 @@ public class EntityItem extends Entity
     	}
     }
     
-    private static void combineItems(EntityItem entityItem1, EntityItem entityItem2) {
-    	entityItem1.item.stackSize += entityItem2.item.stackSize;
-    	entityItem2.item.stackSize = 0;
-    	entityItem1.age = Math.min(entityItem1.age, entityItem2.age);
-    	entityItem1.delayBeforeCanPickup = Math.max(entityItem1.delayBeforeCanPickup, entityItem2.delayBeforeCanPickup);
-    	entityItem2.remove();
+    private static void combineItems(ItemEntity itemEntity1, ItemEntity itemEntity2) {
+    	itemEntity1.item.stackSize += itemEntity2.item.stackSize;
+    	itemEntity2.item.stackSize = 0;
+    	itemEntity1.age = Math.min(itemEntity1.age, itemEntity2.age);
+    	itemEntity1.pickupDelay = Math.max(itemEntity1.pickupDelay, itemEntity2.pickupDelay);
+    	itemEntity2.remove();
     }
-
-    public ItemStack item;
-    private int field_803_e;
-    public int age;
-    public int delayBeforeCanPickup;
-    private int health;
-    public float initialRotation;
-    public int basketPickupDelay = 0;
-    public static boolean enableItemClumping = true;
 }
diff --git a/src/main/java/net/minecraft/core/entity/EntityLightningBolt.java b/src/main/java/net/minecraft/core/entity/LightningEntity.java
similarity index 56%
rename from src/main/java/net/minecraft/core/entity/EntityLightningBolt.java
rename to src/main/java/net/minecraft/core/entity/LightningEntity.java
index a5024280d..11df05144 100644
--- a/src/main/java/net/minecraft/core/entity/EntityLightningBolt.java
+++ b/src/main/java/net/minecraft/core/entity/LightningEntity.java
@@ -1,30 +1,30 @@
 package net.minecraft.core.entity;
 
-import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.util.helper.MathHelper;
 import com.mojang.nbt.CompoundTag;
-import net.minecraft.core.util.phys.Vec3d;
+import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.World;
 
 import java.util.List;
 
 // Referenced classes of package net.minecraft.src:
 //            EntityWeatherEffect, World, MathHelper, Block, 
-//            BlockFire, AxisAlignedBB, Entity, NBTTagCompound, 
+//            FireBlock, AxisAlignedBB, Entity, NBTTagCompound,
 //            Vec3D
 
-public class EntityLightningBolt extends Entity
+public class LightningEntity extends Entity
 {
     private int life;
     public long seed;
     private int flashes;
-    public EntityLightningBolt(World world){
+    public LightningEntity(World world){
         this(world,0, 0, 0);
     }
 
-    public EntityLightningBolt(World world, double x, double y, double z)
+    public LightningEntity(World world, double x, double y, double z)
     {
         super(world);
         seed = 0L;
@@ -55,14 +55,14 @@ public class EntityLightningBolt extends Entity
                 flashes--;
                 life = 1;
                 seed = random.nextLong();
-                if(world.areBlocksLoaded(MathHelper.floor_double(x), MathHelper.floor_double(y), MathHelper.floor_double(z), 10))
+                if(world.areBlocksLoaded(MathHelper.floor(x), MathHelper.floor(y), MathHelper.floor(z), 10))
                 {
-                    int i = MathHelper.floor_double(x);
-                    int j = MathHelper.floor_double(y);
-                    int k = MathHelper.floor_double(z);
-                    if(world.getBlockId(i, j, k) == 0 && Block.fire.canPlaceBlockAt(world, i, j, k))
+                    int i = MathHelper.floor(x);
+                    int j = MathHelper.floor(y);
+                    int k = MathHelper.floor(z);
+                    if(world.getBlockId(i, j, k) == 0 && Blocks.FIRE.canPlaceBlockAt(world, i, j, k))
                     {
-                        world.setBlockWithNotify(i, j, k, Block.fire.id);
+                        world.setBlockWithNotify(i, j, k, Blocks.FIRE.id);
                     }
                 }
             }
@@ -70,7 +70,7 @@ public class EntityLightningBolt extends Entity
         if(life >= 0)
         {
             double radius = 3D;
-            List<Entity> list = world.getEntitiesWithinAABBExcludingEntity(this, AABB.getBoundingBoxFromPool(x - radius, y - radius, z - radius, x + radius, y + 6D + radius, z + radius));
+            List<Entity> list = world.getEntitiesWithinAABBExcludingEntity(this, AABB.getTemporaryBB(x - radius, y - radius, z - radius, x + radius, y + 6D + radius, z + radius));
             for (Entity entity : list)
             {
                 entity.thunderHit(this);
@@ -80,30 +80,30 @@ public class EntityLightningBolt extends Entity
         }
     }
     @Override
-    protected void init(){
+    protected void defineSynchedData(){
 
     }
 
     @Override
     public void spawnInit()
     {
-        if(world.difficultySetting >= 2 && world.areBlocksLoaded(MathHelper.floor_double(x), MathHelper.floor_double(y), MathHelper.floor_double(z), 10))
+        if(world.difficultySetting >= 2 && world.areBlocksLoaded(MathHelper.floor(x), MathHelper.floor(y), MathHelper.floor(z), 10))
         {
-            int i = MathHelper.floor_double(x);
-            int k = MathHelper.floor_double(y);
-            int i1 = MathHelper.floor_double(z);
-            if(world.getBlockId(i, k, i1) == 0 && Block.fire.canPlaceBlockAt(world, i, k, i1))
+            int i = MathHelper.floor(x);
+            int k = MathHelper.floor(y);
+            int i1 = MathHelper.floor(z);
+            if(world.getBlockId(i, k, i1) == 0 && Blocks.FIRE.canPlaceBlockAt(world, i, k, i1))
             {
-                world.setBlockWithNotify(i, k, i1, Block.fire.id);
+                world.setBlockWithNotify(i, k, i1, Blocks.FIRE.id);
             }
             for(int j = 0; j < 4; j++)
             {
-                int l = (MathHelper.floor_double(x) + random.nextInt(3)) - 1;
-                int j1 = (MathHelper.floor_double(y) + random.nextInt(3)) - 1;
-                int k1 = (MathHelper.floor_double(z) + random.nextInt(3)) - 1;
-                if(world.getBlockId(l, j1, k1) == 0 && Block.fire.canPlaceBlockAt(world, l, j1, k1))
+                int l = (MathHelper.floor(x) + random.nextInt(3)) - 1;
+                int j1 = (MathHelper.floor(y) + random.nextInt(3)) - 1;
+                int k1 = (MathHelper.floor(z) + random.nextInt(3)) - 1;
+                if(world.getBlockId(l, j1, k1) == 0 && Blocks.FIRE.canPlaceBlockAt(world, l, j1, k1))
                 {
-                    world.setBlockWithNotify(l, j1, k1, Block.fire.id);
+                    world.setBlockWithNotify(l, j1, k1, Blocks.FIRE.id);
                 }
             }
         }
@@ -120,7 +120,7 @@ public class EntityLightningBolt extends Entity
     }
 
     @Override
-	public boolean shouldRender(Vec3d vec3d)
+	public boolean shouldRender(Vec3 vec3)
     {
         return life >= 0;
     }
